use gme
go


/****** Object:  UserDefinedFunction [dbo].[_f_cExists]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

create FUNCTION [dbo].[_f_cExists] (@table varchar(40), @column varchar(40))  
RETURNS int AS  
/*
  2014-09-24 Klopfer: erstellt
  */
BEGIN 
  declare @ret int
  select @ret = 0
  if exists(select * from sys.objects o join sys.columns c on o.object_id = c.object_id where o.type = 'U' and lower(o.name) = lower(@table) and lower(c.name) = lower(@column))
	select @ret = 1
  return @ret
END




GO
GRANT EXECUTE ON [dbo].[_f_cExists] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[_f_tExists]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[_f_tExists] (@table varchar(40))  
RETURNS int AS  
BEGIN 
  declare @ret int
  select @ret = 0
  if (patindex('8.%', cast(serverproperty('ProductVersion') as varchar)) > 0) begin
  -- SQLServer 2000:
	if exists (select * from dbo.sysobjects where id = object_id(@table) and OBJECTPROPERTY(id, N'IsUserTable') = 1) select @ret = 1
  end
  else begin
  -- ab SQLServer 2005:
	IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(@table) AND type in ('U', 'V')) select @ret = 1
  end
  --
  return @ret
END



GO
GRANT EXECUTE ON [dbo].[_f_tExists] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[bs_f_bseBezeichnungen4bsx2eWert]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[bs_f_bseBezeichnungen4bsx2eWert] (@bsx2eWert int, @bsx2eTyp nvarchar(20))  
RETURNS nvarchar(max) AS  
BEGIN 
if (isnull(@bsx2eWert, 0) = 0) return ''
declare @ret nvarchar(max)
declare @bseBezeichnung nvarchar(80)
declare bseCur cursor for 
  select bseBezeichnung from bs_element join bs_x2e on bseID = bsx2eElement
  where
    bsx2eWert = @bsx2eWert -- der uebergebene xMaster 
    and lower(ltrim(rtrim(bsx2eTyp))) = lower(ltrim(rtrim(@bsx2eTyp)))
  order by bseOrdnung, bseBezeichnung
open bseCur
select @ret = ''
fetch next from bseCur into @bseBezeichnung
while (@@fetch_status <> -1) begin
  select @ret = @ret + case when @ret = '' then '' else ', ' end + @bseBezeichnung
  fetch next from bseCur into @bseBezeichnung
end
close bseCur
deallocate bseCur
return (@ret)
END
GO
GRANT EXECUTE ON [dbo].[bs_f_bseBezeichnungen4bsx2eWert] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[bs_f_bseBezeichnungListe4bsx2e]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE function [dbo].[bs_f_bseBezeichnungListe4bsx2e] (@bsx2eTyp varchar(20), @bsx2eWert int, @bskID int)
returns varchar(max)
as
/* liefert eine Liste von bseBezeichnungen aus dem Inhalt von bs_x2e

	select fBereiche_R, dbo.bs_f_bseBezeichnungListe4bsx2e('be', fID, -20) from firma where fBereiche_R is not null
	update firma set fBereiche_R = dbo.bs_f_bseBezeichnungListe4bsx2e('be', fID, -20) from firma where exists(select 1 from bs_x2e where bsx2eTyp = 'be' and bsx2eWert = fID and bsx2eElement = @bseID)

	2021-06-29	Klopfer: bernommen von datapool
*/

begin

declare @ret varchar(max)
--
select @ret = ''
select @ret = @ret + case when @ret = '' then '' else ', ' end + bseBezeichnung
from bs_x2e join bs_element on bsx2eElement = bseID
where lower(bsx2eTyp) = lower(@bsx2eTyp)
	and bsx2eWert = @bsx2eWert
	and bseKatalog = @bskID
order by bseBezeichnung
--
return @ret
end
GO
GRANT EXECUTE ON [dbo].[bs_f_bseBezeichnungListe4bsx2e] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[bs_f_bseIDListe4bsx2e]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create function [dbo].[bs_f_bseIDListe4bsx2e] (@bsx2eTyp nvarchar(20), @bsx2eWert int, @bskID int)
returns nvarchar(max)
as
/* liefert eine Liste von bseIDs aus dem Inhalt von bs_x2e
	2021-03-21	Klopfer: erstellt (von pm)
*/
begin
declare @ret nvarchar(max)
--
select @ret = ''
select @ret = @ret + case when @ret = '' then '' else ',' end + cast(bseID as varchar)
from bs_x2e join bs_element on bsx2eElement = bseID
where lower(bsx2eTyp) = lower(@bsx2eTyp)
	and bsx2eWert = @bsx2eWert
	and bseKatalog = @bskID
--
return @ret
end
GO
GRANT EXECUTE ON [dbo].[bs_f_bseIDListe4bsx2e] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_aktMandant]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create function [dbo].[f_aktMandant] ()
returns int 
as
/* eigentlich: liefert den ID des aktivierten Mandanten;
  hier aber blind und nur fuer die Kompatibilitaet aufrufender Prozeduren
  history:
  2014-06-16	klopfer: func erstellt
*/
begin
  return (1)
end



GO
GRANT EXECUTE ON [dbo].[f_aktMandant] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_aLoeschbar]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_aLoeschbar] (@ID int)  
RETURNS varchar(255) AS  
BEGIN 
  declare @ret varchar(255)
  select @ret = 
  case when exists(select 1 from beteiligung where bAktion = @ID) then '11' + char(9) + 'Diese Aktion umfasst mindestens eine Beteiligung.'
  end
  if (isnull(@ret, '') = '') begin
	select @ret = '0' + char(9)
  end
  return @ret
END



GO
GRANT EXECUTE ON [dbo].[f_aLoeschbar] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_Anschrift]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[f_Anschrift] (@fID int)
RETURNS nvarchar(255) AS  
BEGIN 
/* vollstndige Aschrift der Firma @fID
	2016-09-18	Klopfer: erstellt
	2016-10-25	Klopfer: Format modifiziert
	*/

return (
	select 
		case when isnull(fOrtsteil, '') = '' then '' else fOrtsteil + ', ' end
		+ case when isnull(fStrasse, '') = '' then '' else fStrasse + ' ' end + char(10)
		+ case when isnull(fPLZ, '') = '' then '' else fPLZ + ' ' end
		+ case when isnull(fOrt, '') = '' then '' else fOrt + ' ' end
	from firma
	where fID = @fID
	)
end


GO
GRANT EXECUTE ON [dbo].[f_Anschrift] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_Beihilfeart4ID]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create function [dbo].[f_Beihilfeart4ID] (@ID int)
returns varchar(20)
as
/* liefert die Bezeichnung der Beihilfeart fr den ID (bBeihilfeart)
  2020-10-23	klopfer: func erstellt
*/
begin
  return case @ID when 1 then 'Zuschuss' when 2 then 'Darlehen' when 3 then 'Brgschaft' end
end
GO
GRANT EXECUTE ON [dbo].[f_Beihilfeart4ID] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_bscLoeschbar]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[f_bscLoeschbar] (@pk int, @user int)  
RETURNS varchar(255) AS  
BEGIN 
  declare @ret varchar(255)
  select @ret = 
  case when (select bscBenutzer from bs_klasse where bscID = @pk) <> @user then '11' + char(9) + 'Sie knnen nur Firmengruppen lschen, die von Ihnen eingerichtet wurden.'
  end
  if (isnull(@ret, '') = '') begin
	select @ret = '0' + char(9)
  end
  return @ret
END

GO
GRANT EXECUTE ON [dbo].[f_bscLoeschbar] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_bseLoeschbar]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[f_bseLoeschbar] (@ID int)  
RETURNS varchar(255) AS  
/*
	2022-03-18	Klopfer: erweitert fr sonstige Merkmale
	*/
BEGIN 
  declare @ret varchar(255)
  declare @bsx2eTyp nvarchar(20)
  select @bsx2eTyp = case bseKatalog when -10 then 'br' /*Branchen*/ when -20 then 'be' /*Bereiche*/ when -30 then 'sm' /*Sonstige Merkmale*/ else '' end from bs_element where bseID = @ID
  --
	-- Branchen / Bereiche / Sonstige Merkmale:
	select @ret = 
	case when exists(select 1 from bs_x2e where bsx2eTyp = @bsx2eTyp and bsx2eElement = @ID) then '11' + char(9) + 'Dieser Eintrag ist mindestens einer Firma zugeordnet.'
  end
  --
  if (isnull(@ret, '') = '') begin
	select @ret = '0' + char(9)
  end
  return @ret
END
GO
GRANT EXECUTE ON [dbo].[f_bseLoeschbar] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_esInt]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
CREATE function [dbo].[f_esInt] (@Gruppe nvarchar(80), @Einstellung nvarchar(255)) 
returns int 
as
/* liefert einen int-wert aus der einstellungstabelle
	2021-03-22	Klopfer: von pm bernommen; null wird nicht 0
*/
begin
--
return
	(select zveIntWert 
	from dbo.zv_einstellung join dbo.zv_einstellungstyp on zvetID = zveEinstellungstyp
	where zvetGruppe = @Gruppe and zvetBezeichnung = @Einstellung
	)
end
GO
GRANT EXECUTE ON [dbo].[f_esInt] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_fLoeschbar]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[f_fLoeschbar] (@ID int)  
RETURNS varchar(255) AS  
BEGIN 
  declare @ret varchar(255)
  select @ret = 
  case when exists(select 1 from firma where fMutterfirma = @ID) then '11' + char(9) + 'Diese Firma ist die Mutterfirma fr mindestens eine andere Firma.' else
  case when exists(select 1 from beteiligung where bFirma = @ID) then '12' + char(9) + 'Diese Firma ist an mindestens einer Aktion beteiligt.'
  end end
  if (isnull(@ret, '') = '') begin
	select @ret = '0' + char(9)
  end
  return @ret
END



GO
GRANT EXECUTE ON [dbo].[f_fLoeschbar] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_fNameX]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_fNameX] (@fID int)
RETURNS nvarchar(520) AS  
BEGIN 
-- komplette Bezeichnung der Firma @fID
-- 2020-12-06	Klopfer: erstellt

return (
	select isnull(fName, '') + case when ISNULL(fName2, '') = '' then '' else ' ' + fName2 end
	from firma
	where fID = @fID
	)
end



GO
GRANT EXECUTE ON [dbo].[f_fNameX] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_Inhaber]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[f_Inhaber] (@fID int)
RETURNS nvarchar(255) AS  
BEGIN 
-- Inhaber der Firma @fID (erstbester Ansprechpartner mit der Rolle Prsident oder Geschftsfhrer)
-- 2016-09-18	Klopfer: erstellt

return (
	select min(dbo.f_pName(pID))
	from person
	where pFirma = @fID
		and pRolle in (0, 1)
	)
end


GO
GRANT EXECUTE ON [dbo].[f_Inhaber] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_lkLoeschbar]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_lkLoeschbar] (@ID int)  
RETURNS varchar(255) AS  
BEGIN 
  declare @ret varchar(255)
  select @ret = 
  case when exists(select 1 from firma where fLandkreis = @ID) then '11' + char(9) + 'Diesem Landkreis ist mindestens eine Firma zugeordnet.'
  end
  if (isnull(@ret, '') = '') begin
	select @ret = '0' + char(9)
  end
  return @ret
END
GO
GRANT EXECUTE ON [dbo].[f_lkLoeschbar] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_Mutterfirma]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

create FUNCTION [dbo].[f_Mutterfirma] (@fID int)
RETURNS nvarchar(255) AS  
BEGIN 
-- Mutter der Firma @fID
-- 2016-09-18	Klopfer: erstellt

return (
	select fm.fName
	from firma fm join firma ft on fm.fID = ft.fMutterfirma
	where ft.fID = @fID
	)
end



GO
GRANT EXECUTE ON [dbo].[f_Mutterfirma] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_pName]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

CREATE FUNCTION [dbo].[f_pName] (@pID int)
RETURNS nvarchar(255) AS  
BEGIN 
-- vollstndiger Name der Person @pID
-- 2016-09-18	Klopfer: erstellt

return (
	select 
		case when isnull(pAnrede, '') = '' then '' else pAnrede + ' ' end
		+ case when isnull(pVorname, '') = '' then '' else pVorname + ' ' end
		+ isnull(pName, '') 
	from person
	where pID = @pID
	)
end


GO
GRANT EXECUTE ON [dbo].[f_pName] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_rLoeschbar]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_rLoeschbar] (@ID int)  
RETURNS varchar(255) AS  
BEGIN 
  declare @ret varchar(255)
  select @ret = 
  case when exists(select 1 from person where pRolle = @ID) then '11' + char(9) + 'Diese Funktion ist mindestens einer Person zugeordnet.'
  end
  if (isnull(@ret, '') = '') begin
	select @ret = '0' + char(9)
  end
  return @ret
END


GO
GRANT EXECUTE ON [dbo].[f_rLoeschbar] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_Sektor4ID]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE function [dbo].[f_Sektor4ID] (@ID int)
returns varchar(20)
as
/* liefert die Sektor-Bezeichnung fr den Sektor-ID
  2015-03-13	klopfer: func erstellt
  2020-10-23	klopfer: DAWI hinzu
*/
begin
  return case @ID when 1 then 'Allgemein' when 2 then 'Fisch' when 3 then 'Agrar' when 4 then 'DAWI' else 'undefiniert' end
end



GO
GRANT EXECUTE ON [dbo].[f_Sektor4ID] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_sql_bLike]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_sql_bLike] (@s varchar(80))  
RETURNS varchar(8000) AS  
BEGIN 
  declare @ls varchar(80)
  select @ls = replace(lower(@s), '*', '%')
 
  return ('(
	(lower(bBemerkung) like ''%' + @ls + '%'')
  )')
END



GO
GRANT EXECUTE ON [dbo].[f_sql_bLike] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_sql_fLike]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[f_sql_fLike] (@s varchar(80))  
/*
	2021-04-22	Klopfer: fName2 hinzu
	2022-03-18	Klopfer: weitere hinzu
	*/
RETURNS varchar(8000) AS  
BEGIN 
  declare @ls varchar(80)
  select @ls = replace(lower(@s), '*', '%')
 
  return ('(
	(lower(fName) like ''%' + @ls + '%'') or
	(lower(fName2) like ''%' + @ls + '%'') or
	(lower(fStrasse) like ''%' + @ls + '%'') or
	(lower(fPLZ) like ''%' + @ls + '%'') or
	(lower(fOrt) like ''%' + @ls + '%'') or
	(lower(fOrtsteil) like ''%' + @ls + '%'') or
	(lower(fTelefon) like ''%' + @ls + '%'') or
	(lower(fFax) like ''%' + @ls + '%'') or
	(lower(fEMail) like ''%' + @ls + '%'') or
	(lower(fHomepage) like ''%' + @ls + '%'') or
	(lower(fKontoNr) like ''%' + @ls + '%'') or
	(lower(fBLZ) like ''%' + @ls + '%'') or
	(lower(fIBAN) like ''%' + @ls + '%'') or
	(lower(fBIC) like ''%' + @ls + '%'') or
	(lower(fBankname) like ''%' + @ls + '%'') or
	(lower(fProdukte) like ''%' + @ls + '%'') or
	(lower(fVertriebsweg) like ''%' + @ls + '%'') or
	(lower(fBesonderheiten) like ''%' + @ls + '%'') or
	(lower(fNeuheiten) like ''%' + @ls + '%'') or
	(lower(fExport) like ''%' + @ls + '%'') or
	(lower(fBranchen_R) like ''%' + @ls + '%'') or
	(lower(fBereiche_R) like ''%' + @ls + '%'') or
	(lower(fSonstigeMerkmale_R) like ''%' + @ls + '%'') or
	(lower(fBemerkung) like ''%' + @ls + '%'') or
	((select lower(lkBezeichnung) from landkreis where lkID = fLandkreis) like ''%' + @ls + '%'')
  )')
END



GO
GRANT EXECUTE ON [dbo].[f_sql_fLike] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_sql_pLike]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[f_sql_pLike] (@s varchar(80))  
RETURNS nvarchar(max) AS  
BEGIN 
  declare @ls varchar(80)
  select @ls = replace(lower(@s), '*', '%')
 
  return ('(
	(lower(pAnrede) like ''%' + @ls + '%'') or
	(lower(pName) like ''%' + @ls + '%'') or
	(lower(pVorname) like ''%' + @ls + '%'') or
	(lower(pEMail) like ''%' + @ls + '%'') or
	(lower(pFax) like ''%' + @ls + '%'') or
	(lower(pTelefon) like ''%' + @ls + '%'') or
	(lower(pMobil) like ''%' + @ls + '%'')
  )')
END



GO
GRANT EXECUTE ON [dbo].[f_sql_pLike] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_zvbName]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_zvbName] (@zvbID int)
RETURNS varchar(35) AS  
BEGIN 
return (
select left(
	case when isnull(zvbGeschlecht, '') = '' then '' else case when zvbGeschlecht = 'w' then 'Frau ' else 'Herr ' end end +
	case when isnull(zvbName, '') = '' then zvbLogin else zvbName + case when isnull(zvbVorname, '') = '' then '' else ', ' + zvbVorname end end
	, 35)
from zv_benutzer
where zvbID = @zvbID
)
end



GO
GRANT EXECUTE ON [dbo].[f_zvbName] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_zveIntWert]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[f_zveIntWert] (@zvetGruppe varchar(80), @zvetBezeichnung varchar(255))
RETURNS int AS  
BEGIN 
return (
select zveIntWert from dbo.zv_einstellung join dbo.zv_einstellungstyp on zveEinstellungstyp = zvetID
where lower(zvetGruppe) = rtrim(ltrim(lower(@zvetGruppe))) and lower(zvetBezeichnung) = rtrim(ltrim(lower(@zvetBezeichnung)))
	and zveMandant = dbo.f_aktMandant()
)
end



GO
GRANT EXECUTE ON [dbo].[f_zveIntWert] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[f_zveTextWert]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE FUNCTION [dbo].[f_zveTextWert] (@zvetGruppe varchar(80), @zvetBezeichnung varchar(255))
RETURNS varchar(255) AS  
BEGIN 
return (
select zveTextWert from dbo.zv_einstellung join dbo.zv_einstellungstyp on zveEinstellungstyp = zvetID
where lower(zvetGruppe) = rtrim(ltrim(lower(@zvetGruppe))) and lower(zvetBezeichnung) = rtrim(ltrim(lower(@zvetBezeichnung)))
	and zveMandant = dbo.f_aktMandant()
)
end



GO
GRANT EXECUTE ON [dbo].[f_zveTextWert] TO [public] AS [dbo]
GO
/****** Object:  UserDefinedFunction [dbo].[rf_f_Nutzer]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create FUNCTION [dbo].[rf_f_Nutzer] (@nID int)
RETURNS nvarchar(255) AS 
/*
	2021-03-22	Klopfer: erstellt
	*/ 
BEGIN 
return dbo.f_zvbName(@nID)
end
GO
GRANT EXECUTE ON [dbo].[rf_f_Nutzer] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[__replaceAll]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[__replaceAll] (@cAlt varchar(10), @cNeu varchar(10), @aTabelle sysname) as
/* ersetzt alle Vorkommen von @cAlt in allen char/varchar/text-Spalten der Tabelle @aTabelle durch @cNeu
	2014-12-19	Klopfer: erstellt
	*/
declare @sMessage varchar(128)
declare @sTabelle sysname, @sFeld sysname, @sTyp sysname
declare @sql varchar(4000), @sqlFeld varchar(255)
declare curFelder scroll cursor for
	select o.name, c.name, t.name 
	from sysobjects o, syscolumns c, systypes t
	where o.id = c.id and c.usertype = t.usertype
	  and o.type = 'U' and t.name in ('char', 'varchar', 'text')
	  and left(o.name, len(@aTabelle)) = @aTabelle
open curFelder
fetch next from curFelder into @sTabelle, @sFeld, @sTyp
while (	@@fetch_status <> -1) begin
	select @sqlFeld = case when (@sTyp = 'text') then 'cast(' + @sFeld + ' as varchar(8000))' else @sFeld end
	select @sql = 'UPDATE ' + @aTabelle + ' set ' + @sFeld + ' = replace(' + @sqlFeld + ', ''' + @cAlt + ''', ''' + replace(@cNeu, '''', '''''') + ''')'
	exec(@sql)
	--select @sql
	
	fetch next from curFelder into @sTabelle, @sFeld, @sTyp
end
close curFelder
deallocate curFelder



GO
GRANT EXECUTE ON [dbo].[__replaceAll] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[__replaceAll_tempdb]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
CREATE procedure [dbo].[__replaceAll_tempdb] (@cAlt varchar(10), @cNeu varchar(10), @aTabelle sysname) as
/* ersetzt alle Vorkommen von @cAlt in allen char/varchar/text-Spalten der Tabelle @aTabelle durch @cNeu
	2013-11-07	Klopfer: erstellt
	2014-12-19	Klopfer: auch fr nvarchar
	*/
declare @sMessage varchar(128)
declare @sTabelle sysname, @sFeld sysname, @sTyp sysname
declare @sql varchar(4000), @sqlFeld varchar(255)
declare curFelder scroll cursor for
	select o.name, c.name, t.name 
	from tempdb..sysobjects o, tempdb..syscolumns c, tempdb..systypes t
	where o.id = c.id and c.usertype = t.usertype
	  and o.type = 'U' and t.name in ('char', 'varchar', 'nvarchar', 'text')
	  and left(o.name, len(@aTabelle)) = @aTabelle
open curFelder
fetch next from curFelder into @sTabelle, @sFeld, @sTyp
while (	@@fetch_status <> -1) begin
	select @sqlFeld = case when (@sTyp = 'text') then 'cast(' + @sFeld + ' as varchar(8000))' else @sFeld end
	select @sql = 'UPDATE ' + @aTabelle + ' set ' + @sFeld + ' = replace(' + @sqlFeld + ', ''' + @cAlt + ''', ''' + replace(@cNeu, '''', '''''') + ''')'
	exec(@sql)
	
	fetch next from curFelder into @sTabelle, @sFeld, @sTyp
end
close curFelder
deallocate curFelder



GO
GRANT EXECUTE ON [dbo].[__replaceAll_tempdb] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[__searchSyscomments]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER OFF
GO
create proc [dbo].[__searchSyscomments] (@Muster varchar(255)) as
/*
  2010-02-26 klopfer: unterscheidet nach SQL Server Version
  */
if (patindex('8.%', cast(serverproperty('ProductVersion') as varchar)) > 0) begin
  -- SQLServer 2000:
  select distinct name from sysobjects o, syscomments c where o.id = c.id and c.text like '%' + @Muster + '%'
end
else begin
  select distinct name from sys.objects o, sys.sql_modules s where o.object_id = s.object_id and s.definition like '%' + @Muster + '%'
end



GO
GRANT EXECUTE ON [dbo].[__searchSyscomments] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[akt_esGarantieren]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--
CREATE PROCEDURE [dbo].[akt_esGarantieren] (
	@esMandant int
) AS
/* garantiert beim mandanten @esMandant fuer jeden allgemeinen einstellungstyp einen eintrag
  2002-06-09 keyn: erstellt
  2010-11-21 klopfer: von sys_~ zu zv_einstellung~
  */
insert into zv_einstellung (zveMandant, zveEinstellungstyp)
select @esMandant, zvetID from zv_einstellungstyp
where isnull(zvetAllgemein, 'T') = 'T' and not exists (select 1 from zv_einstellung where zveMandant = @esMandant and zveEinstellungstyp = zvetID)
--
-- verwaiste allgemeine Einstellungen lschen:
delete from zv_einstellung
where zveBenutzer is null and zveMandant = @esMandant and not exists(select 1 from zv_einstellungstyp where zvetID = zveEinstellungstyp and ISNULL(zvetAllgemein, 'F') = 'T')



GO
GRANT EXECUTE ON [dbo].[akt_esGarantieren] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[akt_Loeschen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[akt_Loeschen] (@bisJahr int, @run bit = 0) AS  
/* Leschen von Altdaten
	2021-03-26	Klopfer: erstellt

	exec dbo.akt_Loeschen 2006, 0
	*/
BEGIN 
	declare @CRLF char(2); select @CRLF = char(13) + char(10)
	declare @sql nvarchar(max), @sqlAction nvarchar(255)
	declare @ret nvarchar(max)
	declare @maxBisJahr int

	-- jngstes Jahr, bis zu dem gelscht werden darf: 
	select @maxBisJahr = datepart(yy, getdate()) - 3

	if (isnull(@bisJahr, 3000) > @maxBisJahr)
		select @ret = 'Sie knnen nur Daten der Vergangenheit bis zum Jahr ' + cast(@maxBisJahr as varchar) + ' lschen.'
	else begin
		select @ret = 'Beteiligungen: ' + cast((select count(*) from beteiligung join aktion on aID = bAktion where isnull(aJahr, isnull(datepart(yy, aVon), @bisJahr + 1)) <= @bisJahr) as varchar)
		if (@run = 1) delete beteiligung from beteiligung join aktion on aID = bAktion where isnull(aJahr, isnull(datepart(yy, aVon), @bisJahr + 1)) <= @bisJahr
		select @ret = @ret + @CRLF + 'Aktionen: ' + cast((select count(*) from aktion where isnull(aJahr, isnull(datepart(yy, aVon), @bisJahr + 1)) <= @bisJahr) as varchar)
		if (@run = 1) delete from aktion where isnull(aJahr, isnull(datepart(yy, aVon), @bisJahr + 1)) <= @bisJahr
		select @ret = @ret + @CRLF + 'Beihilfen Dritter: ' + cast((select count(*) from beihilfe where isnull(bhJahr, isnull(datepart(yy, bhDatum), @bisJahr + 1)) <= @bisJahr) as varchar)
		if (@run = 1) delete from beihilfe where isnull(bhJahr, isnull(datepart(yy, bhDatum), @bisJahr + 1)) <= @bisJahr
	end
	select @ret
END
GO
GRANT EXECUTE ON [dbo].[akt_Loeschen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[akt_zvx2rGarantieren]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create PROCEDURE [dbo].[akt_zvx2rGarantieren] (@zvrID int) AS
--
insert into zv_x2r (zvx2rRolle, zvx2rTyp, zvx2rWert, zvx2rOn, zvx2rBearbeiten) select @zvrID, 'Funktion', zvfID, 'F', 'F' from dbo.zv_funktion
where not exists(select * from zv_x2r where zvx2rRolle = @zvrID and zvx2rTyp = 'Funktion' and zvx2rWert = zvfID)
--



GO
GRANT EXECUTE ON [dbo].[akt_zvx2rGarantieren] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[bs_saveIDs2Klasse]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


CREATE PROCEDURE [dbo].[bs_saveIDs2Klasse] (@bscID int, @typ int, @liste varchar(8000)) AS
/* parst eine liste komma-getrennter IDs und ordnet sie der KLasse zu
	2015-11-08 klopfer: erstellt
*/

declare @lb_stop int 
declare @ls_wert varchar(20)
declare @ll_a int, @ll_e int, @ll_wert int

-- bisherigen Klasseninhalt loeschen:
--delete from bs_x2c where bsx2cKlasse = @bscID

if (isnull(@liste, '') = '') return

-- liste parsen und jeweils den kontext speichern:
select @ll_a = 1
select @lb_stop = 0
while (@lb_stop <> 1) begin
	-- neuen wert extrahieren:
	select @ll_e = charindex(',', @liste, @ll_a)
	if (@ll_e = 0) begin 
		select @ll_e = len(@liste) + 1
		select @lb_stop = 1
	end
	select @ls_wert = substring(@liste, @ll_a, @ll_e - @ll_a) 
	if (@lb_stop <> 1) select @ll_a = @ll_e + 1
	select @ll_wert = convert(int, @ls_wert)
	
	-- der Klasse zuordnen:
	if not exists(select 1 from bs_x2c where bsx2cKlasse = @bscID and bsx2cTyp = @typ and bsx2cMitglied = @ll_wert) 
		insert into bs_x2c (bsx2cKlasse, bsx2cMitglied, bsx2cTyp) values (@bscID, @ll_wert, @typ)
end




GO
GRANT EXECUTE ON [dbo].[bs_saveIDs2Klasse] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[bs_saveWertliste2bsx2e]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[bs_saveWertliste2bsx2e] (@typ nvarchar(20), @eigner int, @bskID int, @liste nvarchar(max), @art int = 0) AS
/* parst eine liste komma-getrennter bseIDs (@art = 0) bzw. bseBezeichnungen (sonst) des Kataloges @bskID und speichert sie einzeln in die Tabelle bs_x2e

	select * from firma where fName like 'Adler%' -- 1791
	delete from bs_x2e where bsx2eWert = 1791 and bsx2eTyp = 'be'
	exec bs_saveWertliste2bsx2e 'be', 1791, -20, 'Direktvermarkter, Gastronomie, Gemeinde, Handwerk, Industrie', 1

	declare @fID int, @fBereiche_R nvarchar(max)
	declare fCur cursor for select fID, fBereiche_R from firma where isnull(fBereiche_R, '') <> '' and not exists(select 1 from bs_x2e where bsx2eWert = fID and bsx2eTyp = 'be')
	open fCur
	fetch next from fCur into @fID, @fBereiche_R
	while (@@fetch_status <> -1) begin
		exec bs_saveWertliste2bsx2e 'be', @fID, -20, @fBereiche_R, 1
		fetch next from fCur into @fID, @fBereiche_R
	end
	close fCur
	deallocate fCur

	--select fName, fName2, fBereiche_R, dbo.bs_f_bseBezeichnungListe4bsx2e('be', fID, -20) BereicheBerechnet from firma
	update firma set fBereiche_R = dbo.bs_f_bseBezeichnungListe4bsx2e('be', fID, -20)
	where isnull(fBereiche_R, '') <> isnull(dbo.bs_f_bseBezeichnungListe4bsx2e('be', fID, -20), '')

	2021-03-21	Klopfer: erstellt (von pm)
	2021-06-30	Klopfer: erweitert um @art; mit try/catch
*/
declare @lb_stop int 
declare @ls nvarchar(255)
declare @ll_a int, @ll_e int, @ll_ID int
-- bisherige Auswahl loeschen:
delete bs_x2e from bs_element where bsx2eElement = bseID and lower(bsx2eTyp) = lower(@typ) and bsx2eWert = @eigner and bseKatalog = @bskID
if (isnull(@liste, '') = '') return
--
-- liste parsen und jeweils den kontext speichern:
select @ll_a = 1
select @lb_stop = 0
while (@lb_stop <> 1) begin
	-- neuen wert extrahieren:
	select @ll_e = charindex(',', @liste, @ll_a)
	if (@ll_e = 0) begin 
		select @ll_e = len(@liste) + 1
		select @lb_stop = 1
	end
	select @ls = ltrim(rtrim(substring(@liste, @ll_a, @ll_e - @ll_a)))
	if (@lb_stop <> 1) select @ll_a = @ll_e + 1
	
	select @ll_ID = null
	begin try
		if (@art = 0)
			select @ll_ID = convert(int, @ls)
		else
			select @ll_ID = (select max(bseID) from bs_element where bseKatalog = @bskID and lower(bseBezeichnung) = lower(@ls)) 
		-- speichern:
		if @ll_ID is not null insert into bs_x2e (bsx2eTyp, bsx2eWert, bsx2eElement) values (@typ, @eigner, @ll_ID)
	end try
	begin catch
	end catch
end
GO
GRANT EXECUTE ON [dbo].[bs_saveWertliste2bsx2e] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[cons_bseBranche]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[cons_bseBranche] (@id_old int, @id_new int) AS
/*
	2014-12-01	klopfer: proc erstellt
*/
 
update bs_x2e set bsx2eElement = @id_new where bsx2eTyp = 'br' and bsx2eElement = @id_old
delete from bs_element where bseID = @id_old

update firma set fBranchen_R = [dbo].[bs_f_bseBezeichnungen4bsx2eWert] (fID, 'br')
where exists(select 1 from bs_x2e where bsx2eTyp = 'br' and bsx2eWert = fID and bsx2eElement = @id_new)


GO
GRANT EXECUTE ON [dbo].[cons_bseBranche] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[d_zvx2r_s]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create proc [dbo].[d_zvx2r_s] (@zvrID int) as
/* history:
*/
--
create table #x2r (
	zvx2rID int null,
	zvx2rTyp varchar(20) null,
	zvx2rWert int null,
	Bezeichnung varchar(80) null,
	zvx2rOn char(1) null,
	zvx2rBearbeiten char(1) null,
	zvrBezeichnung varchar(80) null,
	Bearbeitbar char(1) null,
	Ordnung int null
)
--
delete from zv_x2r where zvx2rTyp = 'Funktion' and not exists (select 1 from zv_funktion where zvfID = zvx2rWert)
--
insert into #x2r (zvx2rID, zvx2rTyp, zvx2rWert, zvx2rOn, zvx2rBearbeiten, zvrBezeichnung) select zvx2rID, zvx2rTyp, zvx2rWert, zvx2rOn, zvx2rBearbeiten, zvrBezeichnung
from zv_x2r join zv_rolle on zvx2rRolle = zvrID
where zvx2rRolle = isnull(@zvrID, zvx2rRolle)
--
-- Bezeichnungen der Funktionen:
update #x2r set Bezeichnung = zvfBezeichnung, Bearbeitbar = zvfBearbeitbar, Ordnung = zvfID from zv_funktion where zvx2rTyp = 'Funktion' and zvx2rWert = zvfID
--
select * from #x2r order by zvx2rTyp desc, Ordnung
--



GO
GRANT EXECUTE ON [dbo].[d_zvx2r_s] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[d_zvx2r_u]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--
create proc [dbo].[d_zvx2r_u] (@zvx2rID int, @zvx2rOn char(1), @zvx2rBearbeiten char(1)) as
--
update zv_x2r set
  zvx2rOn = @zvx2rOn,  zvx2rBearbeiten = @zvx2rBearbeiten
where zvx2rID = @zvx2rID
--



GO
GRANT EXECUTE ON [dbo].[d_zvx2r_u] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[dv_DatenAbfragen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[dv_DatenAbfragen] (@zvzID int) 
/* fhrt die in zv_kontextX abgelegte Datenabfrage aus und hinterlsst das Ergebnis in einer temporren Tabelle 
	exec dv_DatenAbfragen 95
	2021-01-10	klopfer: erstellt (pm)
	2021-03-18	klopfer: hier eingefhrt
*/
AS
BEGIN
set NOCOUNT ON
declare @dvvDatenabfrage nvarchar(max)
declare @error nvarchar(1000)
declare @temptab nvarchar(255)
--
select @error = ''
select @dvvDatenabfrage = max(zvkxListe1) from zv_kontextX where zvkxBenutzer = @zvzID and LOWER(zvkxTyp) = LOWER('dvvDatenabfrage')
if (ISNULL(@dvvDatenabfrage, '') <> '') 
select @temptab = '##dvd' + CAST(@zvzID as varchar) 
exec('if exists (select 1 from tempdb..sysobjects where id = object_id(''tempdb..' + @temptab + ''')) Drop Table ' + @temptab)
begin try
	exec (@dvvDatenabfrage)
end try
begin catch
	select @error = ltrim(str(ERROR_NUMBER())) + CHAR(13) + CHAR(10) + ERROR_MESSAGE()
end catch
--
select @error
END
GO
GRANT EXECUTE ON [dbo].[dv_DatenAbfragen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[lst_alleBeihilfen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[lst_alleBeihilfen] (
	@ID int
	, @vonJahr int = null
	, @bisJahr int = null
	, @IDistFirma int = 0 -- wenn 1, ist @ID der fID; sonst der ID einer Beteiligung
	, @mitAktuellerB int = 0
	, @nurBewilligungen int = 1
) AS
/*
	exec lst_alleBeihilfen 13549, 2018, 2020


	2014-12-01	Klopfer: verwendet nun aJahr, wenn kein Datum zur Beteiligung vorhanden ist; fSektor hinzu
	2014-12-02	Klopfer: verwendet nun bhDatum und aVon, wenn vorhanden
	2014-12-08	Klopfer: nicht die aktuelle Beteiligung mitliefern
	2014-12-17	klopfer: aktuelle Beteiligung abhngig von @mitAktuellerB liefern; Korrektur: Anzeige der Mutter-Daten;
						 neues Arg @IDistFirma (fr Mutterfirmen ohne eigene Beteiligungen) 
	2014-12-19	klopfer: ersetzt Hochkommata
	2015-01-09	klopfer: liefert nun auch die Geschwister der Tchter und das DokDatumn und den Ortsteil
	2015-03-12	klopfer: arg @mitAktuellerB raus (war immer 1); args @Jahre und @bisJahr hinzu
	2015-04-07	klopfer: isnull(bBeihilfe, bBeihilfeVorauss) statt nur bBeihilfe; liefert ggf. keine Beteiligungen der aktuellen Aktion
						 (gilt auch fr Mutter und Tchter; bisher wurde nur die aktuelle Beteiligung ausgeschlossen);
						 liefert auch Status (vorl/endg) des Beihilfebetrages
	2015-11-11	klopfer: Korrektur: Sektor "Agrar" statt "Verein"
	2020-10-23	klopfer: verwendet f_Sektor4ID() und f_Beihilfeart4ID()
	2020-10-29	klopfer: berarbeitung der Berechnung des Schwellenwertes
	2020-11-19	klopfer: bhGeber, bhFoerderbetrag, fBetriebsnummer, bAntragsrueckgabe eingefhrt; beachtet nun den Anfang des Steuerjahres
	2020-12-06	klopfer: fBetriebsnummer raus; nun mit f_fNameX()
	2021-03-25	klopfer: mit bhStatus
	2022-07-11	klopfer: ggf. nur bewilligte (keine beantragten) Beihilfen Dritter; Sektor beteiligungsspezifisch
	*/
BEGIN
	SET NOCOUNT ON;

declare @fID int, @aID int, @fMutterfirma int, @fSpedition char(1), @bBeihilfeVom datetime, @MaxBeihilfe money
declare @fStJahrVonTag int, @fStJahrVonMonat int, @von datetime, @bis datetime
if (@bisJahr is null) select @bisJahr = DATEPART(year, getDate())
if (@vonJahr is null) select @vonJahr = @bisJahr - 2

if (@IDistFirma = 0) 
	-- Aufruf aus einer Beteiligung heraus:
	select @fID = bFirma, @aID = bAktion, @bBeihilfeVom = bBeihilfeVom from beteiligung where bID = @ID
else
	-- Aufruf aus den Stammdaten der Firma heraus:
	select @fID = @ID
-- Eigenschaften der Firma holen:	
select 
	  @fSpedition = ISNULL(fSpedition, 'F')
	, @fMutterfirma = isnull(fMutterfirma, 0)
	, @fStJahrVonTag = ISNULL(fStJahrVonTag, 1)
	, @fStJahrVonMonat = ISNULL(fStJahrVonMonat, 1) 
from firma where fID = @fID
select @von = CONVERT(datetime, cast(@fStJahrVonTag as varchar) + '.' + CAST(@fStJahrVonMonat as varchar) + '.' + CAST(@vonJahr as varchar), 104)
select @bis = dateadd(day, -1, CONVERT(datetime, cast(@fStJahrVonTag as varchar) + '.' + CAST(@fStJahrVonMonat as varchar) + '.' + CAST(@bisJahr + 1 as varchar), 104))

/* temporaere tabelle erzeugen:*/
create table #t (
-- Daten zum adressierten Unternehmen:
  fName nvarchar(520) null
  , fStrasse nvarchar(102) null
  , fPLZ_Ort nvarchar(60) null
  , fIBAN varchar(50) null
  , fBIC varchar(20) null
  , fBankname nvarchar(80) null
  , fFax varchar(35) null
  , aBezeichnung nvarchar(255) null
  , aVon varchar(10) null
  , aBis varchar(10) null
  , aAktenzeichen varchar(30) null
  , bNameX varchar(255) null
  , zvbTelefon varchar(35) null
  , zvbTelefax varchar(35) null
  , zvbEMail varchar(35) null
-- andere Beteiligungen und Beihilfen Dritter, ggf. auch fr verbundene Unternehmen:
  , bhFirma nvarchar(520) null
  , bhAktion nvarchar(255) null
  , bhDatum varchar(10) null
  , bhGeber nvarchar(255) null
  , bhAktenzeichen nvarchar(50) null
  , bhSektor int null
  , Sektor varchar(20) null
  , bhBeihilfeart varchar(20) null
  , bhFoerderbetrag money null
  , bhBetrag money null
  , bhBetragA money null
  , bhStatus char(1) -- vorlufig, endgltig, beantragt
  , bhGesamtbetrag money null
  , bhGesamtbetragA money null
-- Beihilfe:
  , bhMoeglich money null
  , bBescheinigungVom varchar(10) null
  , bAntragsrueckgabe varchar(10) null
  , bBeihilfe money null 
  , vonJahr int null
  , bisJahr int null
  , ANZAHL int null
-- Datum des Schreibens (ggf. frher registriertes):
  , DokDatum varchar(10) null  
  , fNameAdresse nvarchar(520) null -- Adressfeld im Dok Bescheinigung
-- checkboxen fr die Verordnungen in der Bescheinigung:
  , Sektor1 char(1) null
  , Sektor2 char(1) null
  , Sektor3 char(1) null
  , Sektor4 char(1) null
-- nur intern:
  , Datum datetime null -- fr die Sortierung
)

/*************************
	 Beihilfen Dritter laden: 
	 ***********************************************************/
insert into #t (
  bhFirma
  , bhAktion
  , bhDatum
  , bhGeber
  , bhAktenzeichen
  , bhSektor, Sektor
  , bhBeihilfeart
  , bhFoerderbetrag
  , bhBetrag
  , bhBetragA
  , bhStatus
  , vonJahr
  , bisJahr
  , Datum
 )
 -- die Firma selbst:
 select 
   dbo.f_fNameX(fID)
   , bhAktion
   , isnull(CONVERT(varchar(10), bhDatum, 104), CAST(bhJahr as varchar))
   , bhGeber
   , bhAktenzeichen
   , bhSektor, dbo.f_Sektor4ID(bhSektor)
   , dbo.f_Beihilfeart4ID(bhBeihilfeart)
   , bhFoerderbetrag
   , case when isnull(bhBewilligt, 'F') = 'T' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'F' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'T' then bhStatus else 'a' end
   , @vonJahr
   , @bisJahr
   , ISNULL(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as varchar), 104))
 from beihilfe join firma on bhFirma = fID
where fID = @fID 
	and isnull(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as nvarchar), 104)) between @von and @bis
	and ISNULL(bhBewilligt, 'F') = case when @nurBewilligungen = 1 then 'T' else ISNULL(bhBewilligt, 'F') end

 -- die Mutter der Firma:
 union
 select 
   dbo.f_fNameX(fID)
   , bhAktion
   , isnull(CONVERT(varchar(10), bhDatum, 104), CAST(bhJahr as varchar))
   , bhGeber
   , bhAktenzeichen
   , bhSektor, dbo.f_Sektor4ID(bhSektor)
   , dbo.f_Beihilfeart4ID(bhBeihilfeart)
   , bhFoerderbetrag
   , case when isnull(bhBewilligt, 'F') = 'T' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'F' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'T' then bhStatus else 'a' end
   , @vonJahr
   , @bisJahr
   , ISNULL(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as varchar), 104))
 from beihilfe join firma on bhFirma = fID
 where fID = @fMutterfirma 
	and isnull(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as nvarchar), 104)) between @von and @bis
	and ISNULL(bhBewilligt, 'F') = case when @nurBewilligungen = 1 then 'T' else ISNULL(bhBewilligt, 'F') end

 -- die Tchter der Firma:
 union
 select 
   dbo.f_fNameX(fID)
   , bhAktion
   , isnull(CONVERT(varchar(10), bhDatum, 104), CAST(bhJahr as varchar))
   , bhGeber
   , bhAktenzeichen
   , bhSektor, dbo.f_Sektor4ID(bhSektor)
   , dbo.f_Beihilfeart4ID(bhBeihilfeart)
   , bhFoerderbetrag
   , case when isnull(bhBewilligt, 'F') = 'T' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'F' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'T' then bhStatus else 'a' end
   , @vonJahr
   , @bisJahr
   , ISNULL(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as varchar), 104))
 from beihilfe join firma on bhFirma = fID
 where fMutterfirma = @fID 
 	and isnull(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as nvarchar), 104)) between @von and @bis
	and ISNULL(bhBewilligt, 'F') = case when @nurBewilligungen = 1 then 'T' else ISNULL(bhBewilligt, 'F') end

 -- die Tchter der Mutter:
 union
 select 
   dbo.f_fNameX(fID)
   , bhAktion
   , isnull(CONVERT(varchar(10), bhDatum, 104), CAST(bhJahr as varchar))
   , bhGeber
   , bhAktenzeichen
   , bhSektor, dbo.f_Sektor4ID(bhSektor)
   , dbo.f_Beihilfeart4ID(bhBeihilfeart)
   , bhFoerderbetrag
   , case when isnull(bhBewilligt, 'F') = 'T' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'F' then bhBetrag else null end
   , case when isnull(bhBewilligt, 'F') = 'T' then bhStatus else 'a' end
   , @vonJahr
   , @bisJahr
   , ISNULL(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as varchar), 104))
 from beihilfe join firma on bhFirma = fID
 where fMutterfirma = @fMutterfirma 
 	and isnull(bhDatum, convert(datetime, '01.01.' + cast(bhJahr as nvarchar), 104)) between @von and @bis
	and ISNULL(bhBewilligt, 'F') = case when @nurBewilligungen = 1 then 'T' else ISNULL(bhBewilligt, 'F') end

 
/***************************
	 Beteiligungen laden: 
	 ************************************************************************************/
insert into #t (
  bhFirma
  , bhAktion
  , bhDatum
  , bhGeber
  , bhAktenzeichen
  , bhSektor, Sektor
  , bhBeihilfeart
  , bhFoerderbetrag
  , bhBetrag
  , bhStatus
  , vonJahr
  , bisJahr
  , Datum
 )
 -- die Firma selbst:
 select 
   dbo.f_fNameX(fID)
   , aBezeichnung
   , isnull(CONVERT(varchar(10), aVon, 104), CAST(aJahr as varchar))
   , aZuwendungsgeber 
   , aAktenzeichen
   , bSektor, dbo.f_Sektor4ID(bSektor)
   , dbo.f_Beihilfeart4ID(bBeihilfeart)
   , bFoerderbetrag
   , isnull(bBeihilfe, bBeihilfeVorauss)
   , case when bBeihilfe is null then 'v' else 'e' end
   , @vonJahr
   , @bisJahr
  , ISNULL(aVon, convert(datetime, '01.01.' + cast(aJahr as varchar), 104))
 from beteiligung join firma on bFirma = fID 
	join aktion on bAktion = aID
where fID = @fID and bAktion <> case when (@IDistFirma = 1) or (@mitAktuellerB = 1) then 0 else @aID end
	and isnull(bBescheidVom, isnull(aBescheidVom, isnull(aVon, convert(datetime, '01.01.' + cast(aJahr as nvarchar), 104)))) between @von and @bis

	
 -- die Mutter der Firma:
 union
 select 
   dbo.f_fNameX(fID)
   , aBezeichnung
   , isnull(CONVERT(varchar(10), aVon, 104), CAST(aJahr as varchar))
   , aZuwendungsgeber 
   , aAktenzeichen
   , bSektor, dbo.f_Sektor4ID(bSektor)
   , dbo.f_Beihilfeart4ID(bBeihilfeart)
   , bFoerderbetrag
   , isnull(bBeihilfe, bBeihilfeVorauss)
   , case when bBeihilfe is null then 'v' else 'e' end
   , @vonJahr
   , @bisJahr
   , ISNULL(aVon, convert(datetime, '01.01.' + cast(aJahr as varchar), 104))
 from beteiligung join firma on bFirma = fID
	join aktion on bAktion = aID
 where fID = @fMutterfirma
	and bAktion <> case when (@IDistFirma = 1) or (@mitAktuellerB = 1) then 0 else @aID end
	and isnull(bBescheidVom, isnull(aBescheidVom, isnull(aVon, convert(datetime, '01.01.' + cast(aJahr as nvarchar), 104)))) between @von and @bis

 -- die Tchter der Firma:
 union
 select 
   dbo.f_fNameX(fID)
   , aBezeichnung
   , isnull(CONVERT(varchar(10), aVon, 104), CAST(aJahr as varchar))
   , aZuwendungsgeber 
   , aAktenzeichen
   , bSektor, dbo.f_Sektor4ID(bSektor)
   , dbo.f_Beihilfeart4ID(bBeihilfeart)
   , bFoerderbetrag
   , isnull(bBeihilfe, bBeihilfeVorauss)
   , case when bBeihilfe is null then 'v' else 'e' end
   , @vonJahr
   , @bisJahr
   , ISNULL(aVon, convert(datetime, '01.01.' + cast(aJahr as varchar), 104))
 from beteiligung join firma on bFirma = fID
	join aktion on bAktion = aID
 where fMutterfirma = @fID
	and bAktion <> case when (@IDistFirma = 1) or (@mitAktuellerB = 1) then 0 else @aID end
	and isnull(bBescheidVom, isnull(aBescheidVom, isnull(aVon, convert(datetime, '01.01.' + cast(aJahr as nvarchar), 104)))) between @von and @bis

 -- die Tchter der Mutter:
 union
 select 
   dbo.f_fNameX(fID)
   , aBezeichnung
   , isnull(CONVERT(varchar(10), aVon, 104), CAST(aJahr as varchar))
   , aZuwendungsgeber 
   , aAktenzeichen
   , bSektor, dbo.f_Sektor4ID(bSektor)
   , dbo.f_Beihilfeart4ID(bBeihilfeart)
   , bFoerderbetrag
   , isnull(bBeihilfe, bBeihilfeVorauss)
   , case when bBeihilfe is null then 'v' else 'e' end
   , @vonJahr
   , @bisJahr
   , ISNULL(aVon, convert(datetime, '01.01.' + cast(aJahr as varchar), 104))
 from beteiligung join firma on bFirma = fID
	join aktion on bAktion = aID
 where fMutterfirma = @fMutterfirma
	and bAktion <> case when (@IDistFirma = 1) or (@mitAktuellerB = 1) then 0 else @aID end
	and isnull(bBescheidVom, isnull(aBescheidVom, isnull(aVon, convert(datetime, '01.01.' + cast(aJahr as nvarchar), 104)))) between @von and @bis

-- mindestens einen Datensatz garantieren:
if ((select COUNT(*) from #t) = 0) insert into #t (fName, bhFirma) values('', null)

/* Summe bilden:
Erhlt ein einziges Unternehmen De-minimis-Beihilfen nach verschiedenen De-minimis-Verordnungen, so mssen diese zusammen betrachtet und addiert werden. Dabei gelten folgende Regeln:
- Agrar- + Fisch-De-minimis = 30.000 EUR,
- Allgemeine- + Agrar- + Fisch-De-minimis = 200.000 EUR (bzw. 100.000 EUR bei Unternehmen, die im Bereich des gewerblichen Straengterverkehrs ttig sind),
- DAWI- + Allgemeine- + Agrar- + Fisch-De-minimis = 500.000 EUR.
Dabei drfen jedoch die Allgemeine-De-minimis-Beihilfen den Wert von 200.000 EUR bzw. 100.000 EUR bei Unternehmen, die im Bereich des gewerblichen Straengterverkehrs ttig sind
, die Agrar-De-minimis-Beihilfen den Wert von 20.000 EUR und die Fisch-De-minimis-Beihilfen den Wert von 30.000 EUR nicht berschreiten.
*/

select @MaxBeihilfe = 
case when exists(select 1 from #t where bhSektor = 4 /*DAWI*/) then 500000
else case when exists(select 1 from #t where bhSektor = 1 /*Allgemein*/) then case when @fSpedition = 'F' then 200000 else 100000 end 
else case when exists(select 1 from #t where bhSektor = 2 /*Fisch*/) then 30000
else /*Agrar*/ 20000
end end end

update #t set bhGesamtbetragA = (select SUM(isnull(bhBetragA, 0)) from #t)
update #t set bhGesamtbetrag = (select SUM(isnull(bhBetrag, 0)) from #t)
update #t set bhMoeglich = @MaxBeihilfe - bhGesamtbetrag

-- betroffene Sektoren bestimmen (fr die Checkboxen in der Bescheinigung):
if exists(select 1 from #t where bhSektor = 1) update #t set Sektor1 = 'x'
if exists(select 1 from #t where bhSektor = 2) update #t set Sektor2 = 'x'
if exists(select 1 from #t where bhSektor = 3) update #t set Sektor3 = 'x'
if exists(select 1 from #t where bhSektor = 4) update #t set Sektor4 = 'x'

/* Grunddaten eintragen */
if (@IDistFirma = 0)
	-- Angaben zur aktuellen Beteiligung:
	UPDATE #t set
		fName = dbo.f_fNameX(f.fID)
		, fNameAdresse = f.fName + case when ISNULL(f.fName2, '') = '' then '' else CHAR(10) + f.fName2 end
		, fStrasse = case when isnull(f.fOrtsteil, '') = '' then '' else f.fOrtsteil + CHAR(10) end + f.fStrasse
		, fPLZ_Ort = isnull(fPLZ, '') + ' ' + isnull(fOrt, '')
		, fIBAN = f.fIBAN
		, fBIC = f.fBIC
		, fBankname = f.fBankname
		, fFax = f.fFax
		, aBezeichnung = a.aBezeichnung
		, aVon = convert(varchar(10), a.aVon, 104)
		, aBis = convert(varchar(10), a.aBis, 104)
		, aAktenzeichen = a.aAktenzeichen
		, bNameX = dbo.f_zvbName(zvbID)
		, zvbTelefon = zvb.zvbTelefon
		, zvbTelefax = zvb.zvbTelefax
		, zvbEMail = zvb.zvbEMail
		, bBescheinigungVom = convert(varchar(10), GETDATE(), 104)
		, bAntragsrueckgabe = CONVERT(varchar(10), b.bAntragsrueckgabe, 104)
		, bBeihilfe = b.bBeihilfe
	from beteiligung b
		join firma f on b.bFirma = f.fID
		join aktion a on bAktion = a.aID
		left outer join zv_benutzer zvb on aBearbeiter = zvbID
	where bID = @ID
else
	-- Firma hat keine eigene Beteiligung:
	UPDATE #t set
		fName = dbo.f_fNameX(f.fID)
		, fNameAdresse = f.fName + case when ISNULL(f.fName2, '') = '' then '' else CHAR(10) + f.fName2 end
		, fStrasse = case when isnull(f.fOrtsteil, '') = '' then '' else f.fOrtsteil + CHAR(10) end + f.fStrasse
		, fPLZ_Ort = isnull(fPLZ, '') + ' ' + isnull(fOrt, '')
		, fIBAN = f.fIBAN
		, fBIC = f.fBIC
		, fBankname = f.fBankname
		, fFax = f.fFax
	from firma f
	where fID = @ID

-- ggf. Datum des frher registrierten Schreibens eintragen:
update #t set DokDatum = CONVERT(varchar(10), isnull(@bBeihilfeVom, getDate()), 104)

-- Anzahl der Datenstze eintragen (fr Tabellensteuerung beim Seriendruck):
update #t set ANZAHL = (select count(*) from #t)

-- Hochkommata ersetzen (Word hat Probleme mit der Spaltentrennung):
exec __replaceAll_tempdb '"', '''', '#t'
exec __replaceAll_tempdb '', '''', '#t'
exec __replaceAll_tempdb '', '''', '#t'

select * from #t order by bhFirma, Datum, bhAktion, bhAktenzeichen
drop table #t


END




GO
GRANT EXECUTE ON [dbo].[lst_alleBeihilfen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[mcheck_bsc]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--
CREATE procedure [dbo].[mcheck_bsc] (@Stichtag datetime, @zvbID int) AS
/*
	2015-11-09	klopfer: erstellt
	2016-10-25	klopfer: Ordnung nach bscAllgemein hinzu; Benutzer hinzu
	*/
--
select
  'F' 'Checked', 
  bscKuerzel,
  bscBezeichnung,
  bscAllgemein,
  isnull(zvbName, zvbLogin) as Benutzer,
  bscID
from bs_klasse left outer join zv_benutzer on bscBenutzer = zvbID
where (isnull(bscAllgemein, '') = 'T') or (isnull(bscBenutzer, 0) = @zvbID)
order by bscAllgemein, isnull(bscKuerzel, bscBezeichnung)



GO
GRANT EXECUTE ON [dbo].[mcheck_bsc] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[mcheck_bseBereich]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[mcheck_bseBereich] (@Stichtag datetime) AS
/*
 2021-03-21	klopfer: erstellt
*/

select
	'F' 'Checked',
	bseBezeichnung,
	bseID,
	1 Ordnung
from bs_element
where bseKatalog = - 20
union
select
  'F'
  , '<ohne>' 
  , -1
  , 0
order by Ordnung, bseBezeichnung
GO
GRANT EXECUTE ON [dbo].[mcheck_bseBereich] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[mcheck_bseBranche]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[mcheck_bseBranche] (@Stichtag datetime) AS
/*
 2021-03-21	klopfer: erstellt
*/

select
	'F' Checked,
	bseBezeichnung,
	bseID,
	1 Ordnung
from bs_element
where bseKatalog = - 10
union
select
  'F'
  , '<ohne>' 
  , -1
  , 0
order by Ordnung, bseBezeichnung
GO
GRANT EXECUTE ON [dbo].[mcheck_bseBranche] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[mcheck_bseSonstigesMerkmal]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
create procedure [dbo].[mcheck_bseSonstigesMerkmal] (@Stichtag datetime) AS
/*
 2022-03-18	klopfer: erstellt
*/

select
	'F' 'Checked',
	bseBezeichnung,
	bseID,
	1 Ordnung
from bs_element
where bseKatalog = - 30
union
select
  'F'
  , '<ohne>' 
  , -1
  , 0
order by Ordnung, bseBezeichnung
GO
GRANT EXECUTE ON [dbo].[mcheck_bseSonstigesMerkmal] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[mcheck_lk]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE procedure [dbo].[mcheck_lk] (@Stichtag datetime) AS
/*
	2020-10-26	klopfer: erstellt
	2021-03-19	klopfer: <ohne> hinzu
	*/
--
select
  'F' 'Checked', 
  lkBezeichnung,
  lkID
from landkreis
union
select
  'F' Checked
  , '<ohne>' lkBezeichnung
  , 0 lkID
order by lkBezeichnung



GO
GRANT EXECUTE ON [dbo].[mcheck_lk] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[r_aktionen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[r_aktionen] (@nID int) AS
/*	Aktionen auflisten
	2022-06-01	Klopfer: aBescheidVom hinzu

	*/
BEGIN
	SET NOCOUNT ON;

declare @sql varchar(8000), @where varchar(8000)

select @where = zvkxListe1 from zv_kontextX where zvkxBenutzer = @nID and lower(zvkxTyp) = lower('d_r_aktionen')
select @where = replace(@where, '~', '')
if isnull(@where, '') = '' select @where = ' 1 = 1 '

select @sql = '
SELECT [aID]
      ,[aBezeichnung]
      ,[aOrt]
      ,[aJahr]
      ,[aVon]
      ,[aBis]
      ,[aTermin]
      ,[aZuwendungsgeber]
      ,[aAktenzeichen]
      ,[aVerfahren]
      ,[aBemerkung]
      ,[aBearbeiter]
	  , aBescheidVom
  FROM [dbo].[aktion]
'
select @sql = @sql + ' where ' + @where + ' order by aJahr, aVon, aBezeichnung'
exec(@sql)

END



GO
GRANT EXECUTE ON [dbo].[r_aktionen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[r_beteiligungen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[r_beteiligungen] (@nID int) AS
/*
	2014-11-30	klopfer: BV hinzu
	2015-01-11	klopfer: fOrtsteil hinzu
	2015-02-03	klopfer: fGroesse hinzu
	2015-07-19	klopfer: fNichtFoerderfaehig hinzu; fGroesse = 0 wenn nicht frderfhig
	2015-11-04	klopfer: varchar(max) statt 8000
	2015-11-09	klopfer: fID hinzu
	2020-12-06	klopfer: bHatRuecknahme hinzu; f_fNameX()
	2022-06-01	klopfer: fStJahrVon, bBescheidVom, bSektor, bMitteilungVom, bBeihilfeVom hinzu

	*/
BEGIN
	SET NOCOUNT ON;

declare @sql varchar(max), @where varchar(max)

select @where = zvkxListe1 from zv_kontextX where zvkxBenutzer = @nID and lower(zvkxTyp) = lower('d_r_beteiligungen')
select @where = replace(@where, '~', '')
if isnull(@where, '') = '' select @where = ' 1 = 1 '

select @sql = '
SELECT [bID]
      , aBezeichnung
      , aOrt
      , aVon
      , aBis

      , dbo.f_fNameX(fID) as fName
      , fStrasse
      , fOrtsteil
      , fPLZ
      , fOrt
      , case when isnull(fNichtFoerderfaehig, ''F'') = ''T'' then 0 else fGroesse end as fGroesse
      , cast(fStJahrVonTag as nvarchar(2)) + ''.'' + cast(fStJahrVonMonat as nvarchar(2)) + ''.'' as fStJahrVon   
      , fNichtFoerderfaehig
      , fIBAN
      , fBIC
      , fBankname
      
	  , bBescheidVom
      ,[bUmsatz]
      ,[bAntragsrueckgabe]
	  , bSektor
      ,[bBeihilfeart]
      ,[bBeihilfeVorauss]
      ,[bBeihilfe]
      ,[bIstFreigestellt]
      ,[bHatMitteilung]
	  , bMitteilungVom
      ,[bIstGeprueft]
	  , bBeihilfeVom
      ,[bHatMahnung]
      ,[bIstUnvollstaendig]
      ,[bAntragsrueckgabe2]
      ,[bHatErstattung]
      ,[bErstattung]
      ,[bBemerkung]
      , ''F'' as checked
	  , fID
	  , bHatRuecknahme
  FROM beteiligung 
		left outer join firma on bFirma = fID
		left outer join aktion on bAktion = aID
		left outer join zv_benutzer on aBearbeiter = zvbID
'
select @sql = @sql + ' where ' + @where + ' order by aJahr, aVon, aBezeichnung, fName'
exec(@sql)

END




GO
GRANT EXECUTE ON [dbo].[r_beteiligungen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[r_firmen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[r_firmen] (@nID int)
AS
/*
	2015-01-11	klopfer: 4 Felder hinzu
	2015-07-13	klopfer: fNichtFoerderfaehig hinzu
	2015-07-19	klopfer: fGroesse = 0 wenn nicht frderfhig (explizit so gewschnt)
	2015-11-09	klopfer: fBemerkung hinzu
	2016-09-17f. klopfer: fKontoNr und fBLZ raus; fBeschaeftigteJahr, fUmsatzJahr, fAzubiJahr, rInaktiv, rDirektvermarkter, istMutter, UPD_~ hinzu; 
							Reihenfolge fNeuheiten gendert
	2020-10-26	klopfer: fSpedition, fLandkreis, fDVInfo u.a. hinzu
	2020-11-21	klopfer: fStJahrVon statt fWJahrVon
	2020-12-06	klopfer: fNameX
	2021-03-21	klopfer: fBranchen_R und fBereiche_R hinzu
	2022-03-18	klopfer: fSonstigeMerkmale_R hinzu
	*/
BEGIN
	SET NOCOUNT ON;

declare @sql varchar(8000), @where varchar(8000)

select @where = zvkxListe1 from zv_kontextX where zvkxBenutzer = @nID and lower(zvkxTyp) = lower('d_r_firmen')
select @where = replace(@where, '~', '')
if isnull(@where, '') = '' select @where = ' 1 = 1 '

select @sql = '
  SELECT cast ('''' as char(1)) as checked,
		 fID,   
         dbo.f_fNameX(fID) as fName, 
		 case when (select count(*) from firma ft where firma.fID = ft.fMutterfirma) > 0 then ''T'' else ''F'' end as istMutter, 
         (select fName from firma fm where fm.fID = firma.fMutterfirma) as fmName,
         fStrasse,  
         fOrtsteil, 
         fPLZ,   
         fOrt,   
		 fLandkreis,
         fTelefon,   
         fFax,   
         fEMail,   
         fHomepage,   
         cast(fStJahrVonTag as nvarchar(2)) + ''.'' + cast(fStJahrVonMonat as nvarchar(2)) + ''.'' as fStJahrVon,   
         fSektor,   
         case when isnull(fNichtFoerderfaehig, ''F'') = ''T'' then 0 else fGroesse end,  
         fNichtFoerderfaehig, 
         fIBAN,   
         fBIC,   
         fBankname,   
         fGruendungsjahr,   
         fBeschaeftigte,  
		 fBeschaeftigteJahr, 
         fAzubi,   
		 fAzubiJahr,
         fUmsatz,   
		 fUmsatzJahr,
         fBranchen_R, 
         fBereiche_R,  
		 fSonstigeMerkmale_R,
         fProdukte,   
         fBio,
         fNeuheiten,   
         fVertriebsweg,
         fBesonderheiten,   
         fExport,
		 fBemerkung,
		 fInaktiv,
		 fDirektvermarkter,
		 fSpedition,
		 fDVInfo, fDVInfoAm,
		 fDVEinwilligung, fDVEinwilligungAm,
		 UPD_TIME,
		 UPD_USER
    FROM firma
'
select @sql = @sql + ' where ' + @where + ' order by fName'
exec(@sql)

END





GO
GRANT EXECUTE ON [dbo].[r_firmen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[r_personen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[r_personen] (@nID int)
AS
/*
	2015-01-11	klopfer: fOrtsteil hinzu
	2016-09-17	klopfer: pZusatz1, pZusatz2 hinzu
	2016-11-17	klopfer: fEMail hinzu
	2020-12-06	klopfer: fNameX()
	2021-03-19	klopfer: pDVEinwilligung/~am hinzu 
	*/
BEGIN
	SET NOCOUNT ON;

declare @sql varchar(8000), @where varchar(8000)

select @where = zvkxListe1 from zv_kontextX where zvkxBenutzer = @nID and lower(zvkxTyp) = lower('d_r_personen')
select @where = replace(@where, '~', '')
if isnull(@where, '') = '' select @where = ' 1 = 1 '

select @sql = '
  SELECT cast ('''' as char(1)) as checked,
		 fID,   
		 pID,
         dbo.f_fNameX(fID) as fName,  
         (select dbo.f_fNameX(fm.fID) as fName from firma fm where fm.fID = firma.fMutterfirma) as fmName,
         fStrasse, 
         fOrtsteil,  
         fPLZ,   
         fOrt,   
         fTelefon,   
         fFax,   
		 fEMail,
         fSektor,   
         fGroesse,
         pRolle,
		 pZusatz1,
		 pZusatz2,
         pAnrede,
         pName,
         pVorname,
         pEMail,
         pTelefon,
         pMobil,
		 pDVEinwilligung,
		 pDVEinwilligungAm
    FROM firma join person on fID = pFirma
'
select @sql = @sql + ' where ' + @where + ' order by fName, pRolle, pName'
exec(@sql)

END



GO
GRANT EXECUTE ON [dbo].[r_personen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[rf_rfvLoeschen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE proc [dbo].[rf_rfvLoeschen] (@rfvID int) as
/* rfv und abhngige Parameterauswahlen werden gelscht
	2013-11-23	klopfer: erstellt
	2016-10-26	klopfer: toleriert Abwesenheit der rf-Tabellen auer rf_variante
	*/

declare @sql varchar(8000)

-- alles vorhandene lschen:
if (dbo._f_tExists('rf_parameter') = 1) begin

select @sql = '
delete rf_auswahl from rf_parameter join rf_variante on rfpVariante = rfvID where rfpID = rfaParameter and rfvID = ' + str(@rfvID) + ' and rfpKontext = - rfvBenutzer 
delete rf_auswahlX from rf_parameter join rf_variante on rfpVariante = rfvID where rfpID = rfaxParameter and rfvID = ' + str(@rfvID) + ' and rfpKontext = - rfvBenutzer 
delete rf_parameter from rf_variante where rfpVariante = rfvID and rfvID = ' + str(@rfvID) + ' and rfpKontext = - rfvBenutzer'
exec (@sql)

end

delete from rf_variante where rfvID = @rfvID


GO
GRANT EXECUTE ON [dbo].[rf_rfvLoeschen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[zv_akt_x2rGarantieren]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
create PROCEDURE [dbo].[zv_akt_x2rGarantieren] (@zvrID int) AS
/* garantiert fuer alle funktionen eine zuordnung zur benutzer-rolle @zvrID
  2014-11-20	klopfer: aus pm bernommen
*/
exec zv_akt_x2rGarantierenX @zvrID, 'F', 'F'



GO
GRANT EXECUTE ON [dbo].[zv_akt_x2rGarantieren] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[zv_akt_x2rGarantierenX]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
CREATE proc [dbo].[zv_akt_x2rGarantierenX] (@zvrID int, @zvx2rOn char(1), @zvx2rBearbeiten char(1)) as
/* 
  2014-11-20	klopfer: abgespeckt aus pm bernommen
*/ 
declare @zvx2rTypFUNKTION varchar(20)
select @zvx2rTypFUNKTION = 'Funktion'
--
-- Funktionen:
insert into zv_x2r (zvx2rRolle, zvx2rTyp, zvx2rWert, zvx2rOn, zvx2rBearbeiten)
select @zvrID, @zvx2rTypFUNKTION, zvfID, @zvx2rOn, @zvx2rBearbeiten
from zv_funktion
where isnull(zvfStandard, 'F') = 'F' and not exists(select * from zv_x2r where zvx2rRolle = @zvrID and zvx2rWert = zvfID and zvx2rTyp = @zvx2rTypFUNKTION)
--



GO
GRANT EXECUTE ON [dbo].[zv_akt_x2rGarantierenX] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[zv_akt_zvbGarantieren]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
CREATE PROCEDURE [dbo].[zv_akt_zvbGarantieren](@zvbLogin varchar(35), @zvbRolle int, @zvbDomaene int) AS
/* garantiert einen Benutzer mit dem @zvbLogin, und der uebergebenen Rolle und Domaene; liefert den ID des Benutzers ans Frontend
  2014-11-20 	klopfer: aus pm bernommen
*/
declare @zvbID int
if not exists(select * from zv_benutzer where zvbLogin = @zvbLogin and isnull(zvbMandant, dbo.f_aktMandant()) = dbo.f_aktMandant())
  insert into zv_benutzer (zvbLogin, zvbMandant, zvbRolle, zvbDomaene) values (@zvbLogin, dbo.f_aktMandant(), @zvbRolle, @zvbDomaene)
else
  update zv_benutzer set zvbRolle = @zvbRolle, zvbDomaene = @zvbDomaene where zvbLogin = @zvbLogin and isnull(zvbMandant, dbo.f_aktMandant()) = dbo.f_aktMandant()
select @zvbID = (select zvbID from zv_benutzer where zvbLogin = @zvbLogin and isnull(zvbMandant, dbo.f_aktMandant()) = dbo.f_aktMandant())
select @zvbID



GO
GRANT EXECUTE ON [dbo].[zv_akt_zvbGarantieren] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[zv_akt_zvrBegrenzen]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
--
create PROCEDURE [dbo].[zv_akt_zvrBegrenzen] (@zvrID int) AS
/* beschraenkt eine Rolle auf die erlaubten Komponenten
  Funktionen: verwaiste Funktionszeiger raus; keine Standard-Funktionen bei nicht-Standard-Rollen
  2014-11-20	klopfer: abgespeckt aus pm bernommen
*/
--
delete from zv_x2r where zvx2rTyp = 'Funktion' and zvx2rRolle = @zvrID and not exists(select * from zv_funktion where zvfID = zvx2rWert)
--
delete zv_x2r from zv_rolle, zv_funktion
where zvx2rRolle = zvrID and zvx2rWert = zvfID and zvx2rTyp = 'Funktion' and isnull(zvfStandard, 'F') = 'T' and isnull(zvrStandard, 'F') = 'F' and zvrID = @zvrID
--



GO
GRANT EXECUTE ON [dbo].[zv_akt_zvrBegrenzen] TO [public] AS [dbo]
GO
/****** Object:  StoredProcedure [dbo].[zv_akt_zvrGarantieren]    Script Date: 11.07.2022 14:26:56 ******/
SET ANSI_NULLS OFF
GO
SET QUOTED_IDENTIFIER OFF
GO
create PROCEDURE [dbo].[zv_akt_zvrGarantieren](@zvrBezeichnung varchar(80), @zvx2rOn char(1), @zvx2rBearbeiten char(1)) AS
/* garantiert eine Rolle mit der @zvrBezeichnung und den Berechtigungen @zvx2rOn und @zvx2rBearbeiten fuer alle verfuegbaren Funktionen;
  liefert den ID dieser Rolle ans frontend
  2014-11-20	klopfer: aus pm bernommen
*/
declare @zvrID int
-- die rolle garantieren:
if not exists(select * from zv_rolle where lower(zvrBezeichnung) = lower(@zvrBezeichnung) and isnull(zvrStandard, 'F') = 'T' and zvrMandant = dbo.f_aktMandant()) begin
  insert into zv_rolle (zvrBezeichnung, zvrBeschreibung, zvrMandant, zvrStandard, zvrExklusiv) values (@zvrBezeichnung, @zvrBezeichnung, dbo.f_aktMandant(), 'T', 'F')
end
-- die rechte garantieren:
select @zvrID = zvrID from zv_rolle where lower(zvrBezeichnung) = lower(@zvrBezeichnung) and isnull(zvrStandard, 'F') = 'T' and zvrMandant = dbo.f_aktMandant()
exec dbo.zv_akt_x2rGarantierenX @zvrID, @zvx2rOn, @zvx2rBearbeiten
-- die rechte begrenzen:
exec dbo.zv_akt_zvrBegrenzen @zvrID
--
select @zvrID



GO
GRANT EXECUTE ON [dbo].[zv_akt_zvrGarantieren] TO [public] AS [dbo]
GO
